org.apache.ignite.internal.processors.cache

## Interface IgniteCacheOffheapManager

All Known Implementing Classes:
  GridCacheOffheapManager, IgniteCacheOffheapManagerImpl

    public interface IgniteCacheOffheapManager

### Nested Class Summary

Nested Classes
`static interface` `IgniteCacheOffheapManager.CacheDataStore`
`static interface` `IgniteCacheOffheapManager.OffheapInvokeClosure`

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods
`Iterable<IgniteCacheOffheapManager.CacheDataStore>` `cacheDataStores()`
`long` `cacheEntriesCount(int cacheId)`
`long` `cacheEntriesCount(int cacheId, boolean primary, boolean backup, AffinityTopologyVersion topVer)`
`long` `cacheEntriesCount(int cacheId, int part)`
`<K,V> GridCloseableIterator<javax.cache.Cache.Entry<K,V>>` `cacheEntriesIterator(GridCacheContext cctx, boolean primary, boolean backup, AffinityTopologyVersion topVer, boolean keepBinary)`
`GridIterator<CacheDataRow>` `cacheIterator(int cacheId, boolean primary, boolean backup, AffinityTopologyVersion topVer, MvccSnapshot mvccSnapshot)`
`GridCloseableIterator<KeyCacheObject>` `cacheKeysIterator(int cacheId, int part)`
`default GridIterator<CacheDataRow>` `cachePartitionIterator(int cacheId, int part)`
`GridIterator<CacheDataRow>` `cachePartitionIterator(int cacheId, int part, MvccSnapshot mvccSnapshot)`
`void` `clearCache(GridCacheContext cctx, boolean readers)` Clears offheap entries.
`boolean` `containsKey(GridCacheMapEntry entry)` TODO: GG-10884, used on only from initialValue.
`IgniteCacheOffheapManager.CacheDataStore` `createCacheDataStore(int p)`
`IgniteCacheOffheapManager.CacheDataStore` `dataStore(GridDhtLocalPartition part)`
`void` `destroyCacheDataStore(IgniteCacheOffheapManager.CacheDataStore store)`
`void` `dropRootPageForIndex(int cacheId, String idxName)`
`boolean` `expire(GridCacheContext cctx, IgniteInClosure2X<GridCacheEntryEx,GridCacheVersion> c, int amount)`
`long` `expiredSize()` Gets the number of entries pending expire.
`GridAtomicLong` `globalRemoveId()`
`void` `invoke(GridCacheContext cctx, KeyCacheObject key, GridDhtLocalPartition part, IgniteCacheOffheapManager.OffheapInvokeClosure c)`
`long` `lastUpdatedPartitionCounter(int part)` Partition counter provider.
`List<IgniteBiTuple<Object,MvccVersion>>` `mvccAllVersions(GridCacheContext cctx, KeyCacheObject key)` For testing only.
`GridCursor<CacheDataRow>` `mvccAllVersionsCursor(GridCacheContext cctx, KeyCacheObject key, Object x)` Returns iterator over the all row versions for the given key.
`void` `mvccApplyUpdate(GridCacheContext cctx, KeyCacheObject key, CacheObject val, GridCacheVersion ver, long expireTime, GridDhtLocalPartition part, MvccVersion mvccVer)`
`default boolean` `mvccInitialValue(GridCacheMapEntry entry, CacheObject val, GridCacheVersion ver, long expireTime)`
`boolean` `mvccInitialValue(GridCacheMapEntry entry, CacheObject val, GridCacheVersion ver, long expireTime, MvccVersion mvccVer, MvccVersion newMvccVer)`
`boolean` `mvccInitialValueIfAbsent(GridCacheMapEntry entry, CacheObject val, GridCacheVersion ver, long expireTime, MvccVersion mvccVer, MvccVersion newMvccVer, byte txState, byte newTxState)`
`MvccUpdateResult` `mvccLock(GridCacheMapEntry entry, MvccSnapshot mvccSnapshot)`
`CacheDataRow` `mvccRead(GridCacheContext cctx, KeyCacheObject key, MvccSnapshot ver)`
`MvccUpdateResult` `mvccRemove(GridCacheMapEntry entry, MvccSnapshot mvccSnapshot, boolean primary, boolean needHist, boolean needOldVal, CacheEntryPredicate filter, boolean retVal)`
`void` `mvccRemoveAll(GridCacheMapEntry entry)`
`GridLongList` `mvccRemoveNative(boolean primary, GridCacheMapEntry entry, MvccSnapshot mvccSnapshot)`
`MvccUpdateResult` `mvccUpdate(GridCacheMapEntry entry, CacheObject val, GridCacheVersion ver, long expireTime, MvccSnapshot mvccSnapshot, boolean primary, boolean needHist, boolean noCreate, boolean needOldVal, CacheEntryPredicate filter, boolean retVal, javax.cache.processor.EntryProcessor entryProc, Object[] invokeArgs)`
`GridLongList` `mvccUpdateNative(boolean primary, GridCacheMapEntry entry, CacheObject val, GridCacheVersion ver, long expireTime, MvccSnapshot mvccSnapshot)`
`boolean` `mvccUpdateRowWithPreloadInfo(GridCacheMapEntry entry, CacheObject val, GridCacheVersion ver, long expireTime, MvccVersion mvccVer, MvccVersion newMvccVer, byte mvccTxState, byte newMvccTxState)`
`long` `offHeapAllocatedSize()`
`void` `onCacheStarted(GridCacheContext cctx)`
`void` `onKernalStop()`
`void` `onPartitionCounterUpdated(int part, long cntr)` Partition counter update callback.
`void` `onPartitionInitialCounterUpdated(int part, long cntr)` Initial counter will be updated on state restore only
`int` `onUndeploy(ClassLoader ldr)`
`GridIterator<CacheDataRow>` `partitionIterator(int part)`
`CacheDataRow` `read(GridCacheContext cctx, KeyCacheObject key)`
`CacheDataRow` `read(GridCacheMapEntry entry)`
`IgniteRebalanceIterator` `rebalanceIterator(IgniteDhtDemandedPartitionsMap parts, AffinityTopologyVersion topVer)`
`void` `remove(GridCacheContext cctx, KeyCacheObject key, int partId, GridDhtLocalPartition part)`
`GridCloseableIterator<CacheDataRow>` `reservedIterator(int part, AffinityTopologyVersion topVer)`
`ReuseList` `reuseListForIndex(String idxName)`
`RootPage` `rootPageForIndex(int cacheId, String idxName)`
`void` `start(GridCacheSharedContext ctx, CacheGroupContext grp)`
`void` `stop()`
`void` `stopCache(int cacheId, boolean destroy)`
`long` `totalPartitionEntriesCount(int part)`
`void` `update(GridCacheContext cctx, KeyCacheObject key, CacheObject val, GridCacheVersion ver, long expireTime, GridDhtLocalPartition part, CacheDataRow oldRow)`

### Method Detail

#### start

    void start(GridCacheSharedContext ctx,
               CacheGroupContext grp)
        throws IgniteCheckedException

Parameters:
  `ctx` - Context.
  `grp` - Cache group.
Throws:
  `IgniteCheckedException` - If failed.

#### onCacheStarted

    void onCacheStarted(GridCacheContext cctx)
                 throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
Throws:
  `IgniteCheckedException` - If failed.

#### onKernalStop

    void onKernalStop()

#### stopCache

    void stopCache(int cacheId,
                   boolean destroy)

Parameters:
  `cacheId` - Cache ID.
  `destroy` - Destroy data flag. Setting to `true` will remove all cache data.

#### stop

    void stop()

#### onPartitionCounterUpdated

    void onPartitionCounterUpdated(int part,
                                   long cntr)

Partition counter update callback. May be overridden by plugin-provided subclasses.

Parameters:
  `part` - Partition.
  `cntr` - Partition counter.

#### onPartitionInitialCounterUpdated

    void onPartitionInitialCounterUpdated(int part,
                                          long cntr)

Initial counter will be updated on state restore only

Parameters:
  `part` - Partition
  `cntr` - New initial counter

#### lastUpdatedPartitionCounter

    long lastUpdatedPartitionCounter(int part)

Partition counter provider. May be overridden by plugin-provided subclasses.

Parameters:
  `part` - Partition ID.
Returns:
  Last updated counter.

#### read

    @Nullable
    CacheDataRow read(GridCacheMapEntry entry)
                         throws IgniteCheckedException

Parameters:
  `entry` - Cache entry.
Returns:
  Cached row, if available, null otherwise.
Throws:
  `IgniteCheckedException` - If failed.

#### read

    @Nullable
    CacheDataRow read(GridCacheContext cctx,
                                KeyCacheObject key)
                         throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `key` - Key.
Returns:
  Cached row, if available, null otherwise.
Throws:
  `IgniteCheckedException` - If failed.

#### createCacheDataStore

    IgniteCacheOffheapManager.CacheDataStore createCacheDataStore(int p)
                                                           throws IgniteCheckedException

Parameters:
  `p` - Partition.
Returns:
  Data store.
Throws:
  `IgniteCheckedException` - If failed.

#### cacheDataStores

    Iterable<IgniteCacheOffheapManager.CacheDataStore> cacheDataStores()

Returns:
  Iterable over all existing cache data stores.

#### dataStore

    IgniteCacheOffheapManager.CacheDataStore dataStore(GridDhtLocalPartition part)

Parameters:
  `part` - Partition.
Returns:
  Data store.

#### destroyCacheDataStore

    void destroyCacheDataStore(IgniteCacheOffheapManager.CacheDataStore store)
                        throws IgniteCheckedException

Parameters:
  `store` - Data store.
Throws:
  `IgniteCheckedException` - If failed.

#### containsKey

    boolean containsKey(GridCacheMapEntry entry)

TODO: GG-10884, used on only from initialValue.

#### expire

    boolean expire(GridCacheContext cctx,
                   IgniteInClosure2X<GridCacheEntryEx,GridCacheVersion> c,
                   int amount)
            throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `c` - Closure.
  `amount` - Limit of processed entries by single call, `-1` for no limit.
Returns:
  `True` if unprocessed expired entries remains.
Throws:
  `IgniteCheckedException` - If failed.

#### expiredSize

    long expiredSize()
              throws IgniteCheckedException

Gets the number of entries pending expire.

Returns:
  Number of pending entries.
Throws:
  `IgniteCheckedException` - If failed to get number of pending entries.

#### invoke

    void invoke(GridCacheContext cctx,
                KeyCacheObject key,
                GridDhtLocalPartition part,
                IgniteCacheOffheapManager.OffheapInvokeClosure c)
         throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `part` - Partition.
  `c` - Tree update closure.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccRead

    @Nullable
    CacheDataRow mvccRead(GridCacheContext cctx,
                                    KeyCacheObject key,
                                    MvccSnapshot ver)
                             throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `key` - Key.
Returns:
  Cached row, if available, null otherwise.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccAllVersions

    List<IgniteBiTuple<Object,MvccVersion>> mvccAllVersions(GridCacheContext cctx,
                                                            KeyCacheObject key)
                                                     throws IgniteCheckedException

For testing only.

Parameters:
  `cctx` - Cache context.
  `key` - Key.
Returns:
  All stored versions for given key.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccAllVersionsCursor

    GridCursor<CacheDataRow> mvccAllVersionsCursor(GridCacheContext cctx,
                                                   KeyCacheObject key,
                                                   Object x)
                                            throws IgniteCheckedException

Returns iterator over the all row versions for the given key.

Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `x` - Implementation specific argument, `null` always means that we need to return full detached data row.
Returns:
  Iterator over all versions.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccInitialValue

    default boolean mvccInitialValue(GridCacheMapEntry entry,
                                     @Nullable
                                     CacheObject val,
                                     GridCacheVersion ver,
                                     long expireTime)
                              throws IgniteCheckedException

Parameters:
  `entry` - Entry.
  `val` - Value.
  `ver` - Version.
  `expireTime` - Expire time.
Returns:
  `True` if value was inserted.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccInitialValue

    boolean mvccInitialValue(GridCacheMapEntry entry,
                             @Nullable
                             CacheObject val,
                             GridCacheVersion ver,
                             long expireTime,
                             MvccVersion mvccVer,
                             MvccVersion newMvccVer)
                      throws IgniteCheckedException

Parameters:
  `entry` - Entry.
  `val` - Value.
  `ver` - Version.
  `expireTime` - Expire time.
  `mvccVer` - MVCC version.
  `newMvccVer` - New MVCC version.
Returns:
  `True` if value was inserted.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccInitialValueIfAbsent

    boolean mvccInitialValueIfAbsent(GridCacheMapEntry entry,
                                     @Nullable
                                     CacheObject val,
                                     GridCacheVersion ver,
                                     long expireTime,
                                     MvccVersion mvccVer,
                                     MvccVersion newMvccVer,
                                     byte txState,
                                     byte newTxState)
                              throws IgniteCheckedException

Parameters:
  `entry` - Entry.
  `val` - Value.
  `ver` - Version.
  `expireTime` - Expire time.
  `mvccVer` - MVCC version.
  `newMvccVer` - New MVCC version.
  `txState` - Tx state hint for the mvcc version.
  `newTxState` - Tx state hint for the new mvcc version.
Returns:
  `True` if value was inserted.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccUpdate

    @Nullable
    MvccUpdateResult mvccUpdate(GridCacheMapEntry entry,
                                          CacheObject val,
                                          GridCacheVersion ver,
                                          long expireTime,
                                          MvccSnapshot mvccSnapshot,
                                          boolean primary,
                                          boolean needHist,
                                          boolean noCreate,
                                          boolean needOldVal,
                                          @Nullable
                                          CacheEntryPredicate filter,
                                          boolean retVal,
                                          javax.cache.processor.EntryProcessor entryProc,
                                          Object[] invokeArgs)
                                   throws IgniteCheckedException

Parameters:
  `entry` - Entry.
  `val` - Value.
  `ver` - Cache version.
  `expireTime` - Expire time.
  `mvccSnapshot` - MVCC snapshot.
  `primary` - `True` if on primary node.
  `needHist` - Flag to collect history.
  `noCreate` - Flag indicating that row should not be created if absent.
  `needOldVal` - `True` if need old value.
  `filter` - Filter.
  `retVal` - Flag to return previous value.
  `entryProc` - Entry processor.
  `invokeArgs` - Entry processor invoke arguments.
Returns:
  Update result.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccRemove

    @Nullable
    MvccUpdateResult mvccRemove(GridCacheMapEntry entry,
                                          MvccSnapshot mvccSnapshot,
                                          boolean primary,
                                          boolean needHist,
                                          boolean needOldVal,
                                          @Nullable
                                          CacheEntryPredicate filter,
                                          boolean retVal)
                                   throws IgniteCheckedException

Parameters:
  `entry` - Entry.
  `mvccSnapshot` - MVCC snapshot.
  `primary` - `True` if on primary node.
  `needHist` - Flag to collect history.
  `needOldVal` - `True` if need old value.
  `filter` - Filter.
  `retVal` - Flag to return previous value.
Returns:
  Update result.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccLock

    @Nullable
    MvccUpdateResult mvccLock(GridCacheMapEntry entry,
                                        MvccSnapshot mvccSnapshot)
                                 throws IgniteCheckedException

Parameters:
  `entry` - Entry.
  `mvccSnapshot` - MVCC snapshot.
Returns:
  Update result.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccUpdateRowWithPreloadInfo

    boolean mvccUpdateRowWithPreloadInfo(GridCacheMapEntry entry,
                                         @Nullable
                                         CacheObject val,
                                         GridCacheVersion ver,
                                         long expireTime,
                                         MvccVersion mvccVer,
                                         MvccVersion newMvccVer,
                                         byte mvccTxState,
                                         byte newMvccTxState)
                                  throws IgniteCheckedException

Parameters:
  `entry` - Entry.
  `val` - Value.
  `ver` - Version.
  `mvccVer` - MVCC version.
  `newMvccVer` - New MVCC version.
Returns:
  `True` if value was inserted.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccUpdateNative

    GridLongList mvccUpdateNative(boolean primary,
                                  GridCacheMapEntry entry,
                                  CacheObject val,
                                  GridCacheVersion ver,
                                  long expireTime,
                                  MvccSnapshot mvccSnapshot)
                           throws IgniteCheckedException

Parameters:
  `primary` - `True` if on primary node.
  `entry` - Entry.
  `val` - Value.
  `ver` - Cache version.
  `expireTime` - Expire time.
  `mvccSnapshot` - MVCC snapshot.
Returns:
  Transactions to wait for before finishing current transaction.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccRemoveNative

    GridLongList mvccRemoveNative(boolean primary,
                                  GridCacheMapEntry entry,
                                  MvccSnapshot mvccSnapshot)
                           throws IgniteCheckedException

Parameters:
  `primary` - `True` if on primary node.
  `entry` - Entry.
  `mvccSnapshot` - MVCC snapshot.
Returns:
  Transactions to wait for before finishing current transaction.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccRemoveAll

    void mvccRemoveAll(GridCacheMapEntry entry)
                throws IgniteCheckedException

Parameters:
  `entry` - Entry.
Throws:
  `IgniteCheckedException` - If failed.

#### update

    void update(GridCacheContext cctx,
                KeyCacheObject key,
                CacheObject val,
                GridCacheVersion ver,
                long expireTime,
                GridDhtLocalPartition part,
                @Nullable
                CacheDataRow oldRow)
         throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `val` - Value.
  `ver` - Version.
  `expireTime` - Expire time.
  `oldRow` - Old row if available.
  `part` - Partition.
Throws:
  `IgniteCheckedException` - If failed.

#### mvccApplyUpdate

    void mvccApplyUpdate(GridCacheContext cctx,
                         KeyCacheObject key,
                         CacheObject val,
                         GridCacheVersion ver,
                         long expireTime,
                         GridDhtLocalPartition part,
                         MvccVersion mvccVer)
                  throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `val` - Value.
  `ver` - Version.
  `expireTime` - Expire time.
  `part` - Partition.
  `mvccVer` - Mvcc version.
Throws:
  `IgniteCheckedException` - If failed.

#### remove

    void remove(GridCacheContext cctx,
                KeyCacheObject key,
                int partId,
                GridDhtLocalPartition part)
         throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `partId` - Partition number.
  `part` - Partition.
Throws:
  `IgniteCheckedException` - If failed.

#### onUndeploy

    int onUndeploy(ClassLoader ldr)

Parameters:
  `ldr` - Class loader.
Returns:
  Number of undeployed entries.

#### cacheIterator

    GridIterator<CacheDataRow> cacheIterator(int cacheId,
                                             boolean primary,
                                             boolean backup,
                                             AffinityTopologyVersion topVer,
                                             @Nullable
                                             MvccSnapshot mvccSnapshot)
                                      throws IgniteCheckedException

Parameters:
  `cacheId` - Cache ID.
  `primary` - Primary entries flag.
  `backup` - Backup entries flag.
  `topVer` - Topology version.
Returns:
  Rows iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### cachePartitionIterator

    default GridIterator<CacheDataRow> cachePartitionIterator(int cacheId,
                                                              int part)
                                                       throws IgniteCheckedException

Parameters:
  `cacheId` - Cache ID.
  `part` - Partition.
Returns:
  Partition data iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### cachePartitionIterator

    GridIterator<CacheDataRow> cachePartitionIterator(int cacheId,
                                                      int part,
                                                      @Nullable
                                                      MvccSnapshot mvccSnapshot)
                                               throws IgniteCheckedException

Parameters:
  `cacheId` - Cache ID.
  `part` - Partition.
  `mvccSnapshot` - MVCC snapshot.
Returns:
  Partition data iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### partitionIterator

    GridIterator<CacheDataRow> partitionIterator(int part)
                                          throws IgniteCheckedException

Parameters:
  `part` - Partition number.
Returns:
  Iterator for given partition.
Throws:
  `IgniteCheckedException` - If failed.

#### reservedIterator

    GridCloseableIterator<CacheDataRow> reservedIterator(int part,
                                                         AffinityTopologyVersion topVer)
                                                  throws IgniteCheckedException

Parameters:
  `part` - Partition number.
  `topVer` - Topology version.
Returns:
  Iterator for given partition that will reserve partition state until it is closed.
Throws:
  `IgniteCheckedException` - If failed.

#### rebalanceIterator

    IgniteRebalanceIterator rebalanceIterator(IgniteDhtDemandedPartitionsMap parts,
                                              AffinityTopologyVersion topVer)
                                       throws IgniteCheckedException

Parameters:
  `parts` - Partitions.
Returns:
  Partition data iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### cacheEntriesIterator

    <K,V> GridCloseableIterator<javax.cache.Cache.Entry<K,V>> cacheEntriesIterator(GridCacheContext cctx,
                                                                                   boolean primary,
                                                                                   boolean backup,
                                                                                   AffinityTopologyVersion topVer,
                                                                                   boolean keepBinary)
                                                                            throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
  `primary` - Primary entries flag.
  `backup` - Backup entries flag.
  `topVer` - Topology version.
  `keepBinary` - Keep binary flag.
Returns:
  Entries iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### cacheKeysIterator

    GridCloseableIterator<KeyCacheObject> cacheKeysIterator(int cacheId,
                                                            int part)
                                                     throws IgniteCheckedException

Parameters:
  `cacheId` - Cache ID.
  `part` - Partition.
Returns:
  Iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### cacheEntriesCount

    long cacheEntriesCount(int cacheId,
                           boolean primary,
                           boolean backup,
                           AffinityTopologyVersion topVer)
                    throws IgniteCheckedException

Parameters:
  `cacheId` - Cache ID.
  `primary` - Primary entries flag.
  `backup` - Backup entries flag.
  `topVer` - Topology version.
Returns:
  Entries count.
Throws:
  `IgniteCheckedException` - If failed.

#### clearCache

    void clearCache(GridCacheContext cctx,
                    boolean readers)

Clears offheap entries.

Parameters:
  `cctx` - Cache context.
  `readers` - `True` to clear readers.

#### cacheEntriesCount

    long cacheEntriesCount(int cacheId,
                           int part)

Parameters:
  `cacheId` - Cache ID.
  `part` - Partition.
Returns:
  Number of entries in given partition.

#### offHeapAllocatedSize

    long offHeapAllocatedSize()

Returns:
  Offheap allocated size.

#### globalRemoveId

    GridAtomicLong globalRemoveId()

Returns:
  Global remove ID counter.

#### rootPageForIndex

    RootPage rootPageForIndex(int cacheId,
                              String idxName)
                       throws IgniteCheckedException

Parameters:
  `cacheId` - Cache ID.
  `idxName` - Index name.
Returns:
  Root page for index tree.
Throws:
  `IgniteCheckedException` - If failed.

#### dropRootPageForIndex

    void dropRootPageForIndex(int cacheId,
                              String idxName)
                       throws IgniteCheckedException

Parameters:
  `cacheId` - Cache ID.
  `idxName` - Index name.
Throws:
  `IgniteCheckedException` - If failed.

#### reuseListForIndex

    ReuseList reuseListForIndex(String idxName)
                         throws IgniteCheckedException

Parameters:
  `idxName` - Index name.
Returns:
  Reuse list for index tree.
Throws:
  `IgniteCheckedException` - If failed.

#### cacheEntriesCount

    long cacheEntriesCount(int cacheId)

Parameters:
  `cacheId` - Cache ID.
Returns:
  Number of entries.

#### totalPartitionEntriesCount

    long totalPartitionEntriesCount(int part)

Parameters:
  `part` - Partition.
Returns:
  Number of entries.

2018 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.7.5
Release Date | : June 4 2019